package com.wcs.back.service;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.wcs.back.domain.WcsResult;

import javax.servlet.http.HttpServletRequest;

/**
 * wcs回调Interface
 *
 * @author zf
 * @date 2023/11/27
 */
public interface IWcsService {
    /**
     * 普通搬运任务下发
     * @param json
     * @return
     */
    WcsResult SetUp_Task(String json, HttpServletRequest request) throws JsonProcessingException;

    /**
     * 机械臂拆托任务下发
     * @param json
     * @param request
     * @return
     */
    WcsResult Dismantling_Task(String json, HttpServletRequest request) throws JsonProcessingException;

    /**
     * CTU任务下发
     * @param json
     * @param request
     * @return
     */
    WcsResult SetUp_CTUTask(String json, HttpServletRequest request) throws JsonProcessingException;

    /**
     * 滚筒线任务下发
     * @param json
     * @param request
     * @return
     */
    WcsResult DrumLine_Task(String json, HttpServletRequest request) throws JsonProcessingException;

    /**
     * 指令下发
     * @param json
     * @param request
     * @return
     */
    WcsResult Directives(String json, HttpServletRequest request) throws JsonProcessingException;
}
